// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.0
//
// <auto-generated>
//
// Generated from file `Plugin.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

#ifndef __Ice_Plugin_h__
#define __Ice_Plugin_h__

#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/StreamHelpers.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/Optional.h>
#include <Ice/LoggerF.h>
#include <Ice/BuiltinSequences.h>
#include <Ice/UndefSysMacros.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 305
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 0
#       error Ice patch level mismatch!
#   endif
#endif

#ifndef ICE_API
#   ifdef ICE_API_EXPORTS
#       define ICE_API ICE_DECLSPEC_EXPORT
#   else
#       define ICE_API ICE_DECLSPEC_IMPORT
#   endif
#endif

namespace Ice
{

class Plugin;
bool operator==(const Plugin&, const Plugin&);
bool operator<(const Plugin&, const Plugin&);
ICE_API ::Ice::LocalObject* upCast(::Ice::Plugin*);
typedef ::IceInternal::Handle< ::Ice::Plugin> PluginPtr;

class PluginManager;
bool operator==(const PluginManager&, const PluginManager&);
bool operator<(const PluginManager&, const PluginManager&);
ICE_API ::Ice::LocalObject* upCast(::Ice::PluginManager*);
typedef ::IceInternal::Handle< ::Ice::PluginManager> PluginManagerPtr;

}

namespace Ice
{

class ICE_API Plugin : virtual public ::Ice::LocalObject
{
public:

    typedef PluginPtr PointerType;

    virtual void initialize() = 0;

    virtual void destroy() = 0;
};

inline bool operator==(const Plugin& l, const Plugin& r)
{
    return static_cast<const ::Ice::LocalObject&>(l) == static_cast<const ::Ice::LocalObject&>(r);
}

inline bool operator<(const Plugin& l, const Plugin& r)
{
    return static_cast<const ::Ice::LocalObject&>(l) < static_cast<const ::Ice::LocalObject&>(r);
}

class ICE_API PluginManager : virtual public ::Ice::LocalObject
{
public:

    typedef PluginManagerPtr PointerType;

    virtual void initializePlugins() = 0;

    virtual ::Ice::StringSeq getPlugins() = 0;

    virtual ::Ice::PluginPtr getPlugin(const ::std::string&) = 0;

    virtual void addPlugin(const ::std::string&, const ::Ice::PluginPtr&) = 0;

    virtual void destroy() = 0;
};

inline bool operator==(const PluginManager& l, const PluginManager& r)
{
    return static_cast<const ::Ice::LocalObject&>(l) == static_cast<const ::Ice::LocalObject&>(r);
}

inline bool operator<(const PluginManager& l, const PluginManager& r)
{
    return static_cast<const ::Ice::LocalObject&>(l) < static_cast<const ::Ice::LocalObject&>(r);
}

}

#endif
